<?php
/**
 * @package   Switips
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

//jbdump($params);

class SwitipsControllerCategories extends JControllerLegacy
{
  
  public $redirect_categories = 'index.php?option=com_switips&controller=categories';

  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){
    $categories = $this->getCategories();
    $view = $this->getView('switips', 'html');
    $view->setLayout('categories');
    $view->assign('categories', $categories);
    $view->displayCategories();    
  }

  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }

    $data = $this->input->post->getArray();

    if(isset($data['category']) && is_array($data['category'])){
      $this->saveCommission($data['category']); 
    }
    
   $this->setRedirect($this->redirect_categories); 
  }
  
  function getCategories(){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{
      $query = "SELECT `category_id`, `commission`, `category_name`, `category_depth` FROM  #__hikashop_category WHERE `category_type`='product' ORDER BY `category_left` ASC";
      $db->setQuery($query);
      $list = $db->loadAssocList();
      
      $return = [];
      foreach($list as $l){
        $object = new stdClass();
        $object->category_id = $l['category_id'];
        $object->category_name = $l['category_name'];
        $object->category_depth = $l['category_depth'];
        $object->commission = !empty($l['commission']) ? $l['commission'] : 0;
        
        $return[$l['category_id']] = $object;
      }

      return $return;
    } 
  }
  
  function saveCommission($categories = []){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{      
      
      foreach($categories as $category_id=>$commission){
        $query = $db->getQuery(true);
        $fields = [
          $db->quoteName('commission').'="'.$commission.'"',
        ];
        
        $conditions = [
          $db->quoteName('category_id').'='.$category_id, 
        ];
        
        $query->update($db->quoteName('#__hikashop_category'))->set($fields)->where($conditions);
        $db->setQuery($query);
        $db->execute();           
      }
      
      return true;
    } 
  }

}    