<?php
/**
 * @package   Switips
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

//jbdump($params);

class SwitipsControllerProducts extends JControllerLegacy
{
  
  public $redirect_categories = 'index.php?option=com_switips&controller=products';

  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){
    $check_cat = 0;
    $products = [];

    
    $category = $this->input->get('category', 'no');  
    $categories = $this->getCategories();

    if(is_numeric($category)){
      $check_cat = $category;
      $products = $this->getProducts($category);
    }

    $view = $this->getView('switips', 'html');
    $view->setLayout('products');
    $view->assign('check_cat', $check_cat);
    $view->assign('categories', $categories);
    $view->assign('products', $products);
    $view->displayProducts();
  }
  
  function getCategories(){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{
      $query = "SELECT `category_id`, `commission`, `category_name`, `category_depth` FROM  #__hikashop_category WHERE `category_type`='product' ORDER BY `category_left` ASC";
      $db->setQuery($query);
      $list = $db->loadAssocList();
      
      $return = [];
      foreach($list as $l){
        $object = new stdClass();
        $object->category_id = $l['category_id'];
        $object->category_name = $l['category_name'];
        $object->category_depth = $l['category_depth'];
        $object->commission = !empty($l['commission']) ? $l['commission'] : 0;
        
        $return[$l['category_id']] = $object;
      }

      return $return;
    } 
  }  
  
  public function getProducts($category_id){
    $db = JFactory::getDBO();

    $query = "SELECT prd.product_id, prd.commission, prd.product_name, prd.product_sort_price FROM `#__hikashop_product_category` AS prd_cat
              LEFT JOIN `#__hikashop_product` AS prd ON prd.product_id = prd_cat.product_id
              WHERE prd_cat.category_id=".(int)$category_id;
    $db->setQuery($query);
    $data = $db->loadAssocList();
    
    $return = [];
    foreach($data as $d){
      $object = new stdClass();
      $object->product_id = $d['product_id'];
      $object->product_name = $d['product_name'];
      $object->product_price = $d['product_sort_price'];
      $object->commission = !empty($d['commission']) ? $d['commission'] : 0; 
      
      $return[$d['product_id']] = $object;
    }
    
    return $return;
  }    
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }

    $data = $this->input->post->getArray();

    if(isset($data['product']) && is_array($data['product'])){
      $this->saveCommission($data['product']); 
    }

    $category = $this->input->get('category', '');
    
    if(is_numeric($category)){
      $this->setRedirect($this->redirect_categories.'&category='.$category);
    }else{
      $this->setRedirect($this->redirect_categories); 
    }   
    
  }
  
  function saveCommission($products = []){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{      
      
      foreach($products as $product_id=>$commission){
        $query = $db->getQuery(true);
        $fields = [
          $db->quoteName('commission').'="'.$commission.'"',
        ];
        
        $conditions = [
          $db->quoteName('product_id').'="'.$product_id.'"', 
        ];
        
        $query->update($db->quoteName('#__hikashop_product'))->set($fields)->where($conditions);
        $db->setQuery($query);
        $db->execute();           
      }
      
      return true;
    } 
  } 
}    